unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, TeeGDIPlus, TeEngine, ExtCtrls, TeeProcs, Chart, StdCtrls;

type
  TForm1 = class(TForm)
    Chart1: TChart;
    RadioGroup1: TRadioGroup;
    CheckBox1: TCheckBox;
    CheckBox2: TCheckBox;
    procedure FormCreate(Sender: TObject);
    procedure RadioGroup1Click(Sender: TObject);
    procedure CheckBox1Click(Sender: TObject);
    procedure CheckBox2Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

uses Series, DateUtils;

procedure TForm1.CheckBox1Click(Sender: TObject);
var i: Integer;
begin
  for i:=0 to Chart1.SeriesCount-1 do
    if (Chart1[i] is TFastLineSeries) then
      (Chart1[i] as TFastLineSeries).DrawAllPoints:=CheckBox1.Checked;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  RadioGroup1.ItemIndex:=0;
end;

procedure TForm1.RadioGroup1Click(Sender: TObject);
var i, x: Integer;
    tmpDate: TDateTime;
begin
  Chart1.ClearChart;
  Chart1.View3D:=False;

  Chart1.AutoRepaint:=False;

  for i:=0 to 17-1 do
    with Chart1.AddSeries(TFastLineSeries) as TFastLineSeries do
    begin
      tmpDate:=StrToDate('01/01/2000');

      if RadioGroup1.ItemIndex=0 then
      begin
        XValues.DateTime:=True;
        AddXY(tmpDate, 10000+random*10000)
      end
      else
        AddXY(0, 10000+random*10000, FormatDateTime('dd/mm/yyyy', tmpDate));

      for x:=1 to 85000-1 do
      begin
        tmpDate:=IncDay(tmpDate);

        if RadioGroup1.ItemIndex=0 then
           AddXY(tmpDate, YValue[x-1] + random*10 - 5)
        else
           AddXY(x, YValue[x-1] + random*10 - 5, FormatDateTime('dd/mm/yyyy', tmpDate));
      end;

      DrawAllPoints:=CheckBox1.Checked;
    end;

  Chart1.AutoRepaint:=True;
end;

procedure TForm1.CheckBox2Click(Sender: TObject);
var i, tmpW, tmpLastW, tmpPos, tmpLastPos: Integer;
begin
  if (RadioGroup1.ItemIndex=1) and CheckBox2.Checked then
  begin
    Chart1.Canvas.Font.Assign(Chart1.Axes.Bottom.LabelsFont);
    Chart1.Axes.Bottom.Items.Clear;

    Chart1.Axes.Bottom.Items.Add(Chart1[0].XValue[0], Chart1[0].Labels[0]);
    tmpLastPos:=Chart1[0].CalcXPos(0);
    tmpLastW:=Chart1.Canvas.TextWidth(Chart1[0].Labels[0]);
    for i:=1 to Chart1[0].Count-1 do
    begin
      tmpPos:=Chart1[0].CalcXPos(i);
      tmpW:=Chart1.Canvas.TextWidth(Chart1[0].Labels[i]);
      if tmpLastPos+(tmpLastW/2)<tmpPos-(tmpW/2) then
      begin
        Chart1.Axes.Bottom.Items.Add(Chart1[0].XValue[i], Chart1[0].Labels[i]);
        tmpLastPos:=tmpPos;
        tmpLastW:=tmpW;
      end;
    end;

  end;
end;

end.
